﻿using System;
using System.Threading;
using System.Threading.Tasks;
using System.Diagnostics;
using static System.Console;

namespace SynchronizowanieDostepuDoZasobow
{
   class Program
   {
      static object koncha = new object();      
      static Random r = new Random();
      static string Komunikat; // wspólny zasób
      static int Licznik; // kolejny wspólny zasób

      static void MetodaA()
      {
         try
         {
            Monitor.TryEnter(koncha, TimeSpan.FromSeconds(15));
            for (int i = 0; i < 5; i++)
            {
               Thread.Sleep(r.Next(2000));
               Komunikat += "A";
               Interlocked.Increment(ref Licznik);
               Write(".");
            }
         }
         finally
         {
            Monitor.Exit(koncha);
         }
      }

      static void MetodaB()
      {
         try
         {
            Monitor.TryEnter(koncha, TimeSpan.FromSeconds(15));
            for (int i = 0; i < 5; i++)
            {
               Thread.Sleep(r.Next(2000));
               Komunikat += "A";
               Interlocked.Increment(ref Licznik);
               Write(".");
            }
         }
         finally
         {
            Monitor.Exit(koncha);
         }
      }

      static void Main(string[] args)
      {
         OutputEncoding = new System.Text.UTF8Encoding();

         WriteLine("Proszę poczekać na zakończenie pracy przez zadania.");
         Stopwatch stoper = Stopwatch.StartNew();
         Task a = Task.Factory.StartNew(MetodaA);
         Task b = Task.Factory.StartNew(MetodaB);
         Task.WaitAll(new Task[] { a, b });
         WriteLine();
         WriteLine($"Wyniki: {Komunikat}.");
         WriteLine($"Upłynęło {stoper.ElapsedMilliseconds:#,##0} milisekund.");
         WriteLine($"Ciąg znaków zmieniono {Licznik} razy.");

         ReadKey();
      }
   }
}
